Name:			A-Tune-BPF-Collection
Version:		1.0.0
Release:		4
License:		Mulan PSL v2
Summary:		BPF program collection to adjust fine-grained kernel mode to get better performance
URL:			https://gitee.com/openeuler/A-Tune-BPF-Collection
Source0:		https://gitee.com/openeuler/A-Tune-BPF-Collection/repository/archive/v%{version}.tar.gz

Patch1: README-add-source-code-compilation-description.patch
Patch2: common_helper-add-comment-and-bugfix-for-config-pars.patch
Patch3: add-test-framework-and-testcasese.patch
Patch4: use-generated-vmlinux.h-instead-of-bpftool-gen-vmlin.patch
Patch5: Add-stack-protector-compile-option.patch

BuildRequires: clang, llvm, libbpf-devel
Requires: libbpf
Provides: readahead_tune

%description
A-Tune BPF Collection contains a set of BPF program which can interact with kernel in real time.
It has the following capabilities:
readahead_tune: trace file reading characteristics, then ajust file read mode to get maximum I/O efficency

%prep
%autosetup -n %{name}-v%{version} -p1

%build
make %{?_smp_mflags}

%install
install -D -p -m 0755 readahead_tune %{buildroot}/%{_sbindir}/readahead_tune
install -D -p -m 0644 readahead_tune.bpf.o %{buildroot}/%{_sbindir}/readahead_tune.bpf.o
install -D -p -m 0755 start_readahead_tune %{buildroot}/%{_sbindir}/start_readahead_tune
install -D -p -m 0755 stop_readahead_tune %{buildroot}/%{_sbindir}/stop_readahead_tune
install -D -p -m 0644 readahead_tune.conf %{buildroot}%{_sysconfdir}/sysconfig/readahead_tune.conf

%check
make check

%files
%{_sbindir}/readahead_tune
%{_sbindir}/readahead_tune.bpf.o
%{_sbindir}/start_readahead_tune
%{_sbindir}/stop_readahead_tune
%config(noreplace) %{_sysconfdir}/sysconfig/readahead_tune.conf

%changelog
* Mon Oct 17 lvying<lvying6@huawei.com> - 1.0.0-4
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:some enhancement:
	README: add source code compilation description
	common_helper: add comment and bugfix for config parse
	add test framework and testcasese

* Wed Mar 9 2022 lvying<lvying6@huawei.com> - 1.0.0-3
- Type:enhancement
- ID:NA
- SUG:NA
- DESC: Add stack protector compile option

* Wed Dec 8 2021 lvying<lvying6@huawei.com> - 1.0.0-2
- Type:bugfix
- ID:NA
- SUG:NA
- DESC: use generated vmlinux.h instead of bpftool gen vmlinux.h in compile env

* Tue Nov 9 2021 lvying<lvying6@huawei.com> - 1.0.0-1
- Type:feature
- ID:NA
- SUG:NA
- DESC: Init A-Tune-BPF-Collection repo and add readahead_tune service 
